//
// Copyright (c) 2012 Secret Geometry, Inc.. All rights reserved.
//

#ifndef SSH_HPP
#define SSH_HPP

#include <stdint.h>
#include <string.h>

namespace term {

class SshImplementation;

// 
// Ssh
// 

class Ssh
{
  public:
    
    // 
    Ssh(int width,
        int height,
        const char* workingDir,
        const char* language,
        const char* termIdentifier,
        const char* cathodeIdentifier);
    
    // 
    ~Ssh();
    
    // 
    const char* activeProcessName();
    
    // 
    bool isRunning() const;
    
    //
    int processCount() const;
    
    //
    void resize(int width, int height);
    
    //
    int read(uint8_t* str, size_t count);
    
    //
    int write(const uint8_t* str, size_t count);
    
  private:
    
    SshImplementation* imp;
};
    
} // term

#endif // SSH_HPP
