//
// Copyright (c) 2012 Secret Geometry, Inc.. All rights reserved.
//

#ifndef PTY_HPP
#define PTY_HPP

#include <stdint.h>     // for uint8_t
#include <sys/sysctl.h> // for pid_t

namespace term {

// 
// Pty
// 

class Pty
{
  public:

    // 
    Pty(int width,
        int height,
        const char* workingDir,
        const char* language,
        const char* termIdentifier,
        const char* cathodeIdentifier);
    
    // 
    ~Pty();
    
    // 
    const char* activeProcessName();

    // 
    bool isRunning() const;
    
    //
    int processCount() const;
    
    //
    void resize(int width, int height);

    //
    int read(uint8_t* str, size_t count);

    //
    int write(const uint8_t* str, size_t count);

  private:
    
    static void childProcessEnded(int sig);
    static void service();

    pid_t pid;
    int   file;
    bool  running;
    char  topProcName[MAXCOMLEN + 1];
};

} // term

#endif // PTY_HPP
