//
// Copyright (c) 2012 Secret Geometry, Inc.. All rights reserved.
//

#ifndef DISPATCHER_HPP
#define DISPATCHER_HPP

#include "Utilities.hpp"
#include "Types.hpp"
#include <stdint.h>

namespace term {

// 
// Dispatcher
//
// 
// 

class Dispatcher
{
  public:
    
    //
    Dispatcher(Context& c);
    
    //
    void text(uint32_t c);
    
    //
    void diacritic(uint32_t d);
    
    //
    void controlChar(uint8_t c);
    
    //
    void escapeSequence(uint8_t c, const EscapeArgs& args);
    
    //
    void characterSetSequence(uint8_t c, const EscapeArgs& args);
    
    //
    void lineAttributeSequence(uint8_t c);
    
    //
    void controlSequence(uint8_t c, bool questionMark, const ControlArgs& args);
    
    //
    void osCommand(const uint8_t* command);
	
  private:
	
	Context& context;
};

} // namespace term

#endif // DISPATCHER_HPP
